#include <can.h>
#include <mcp2515.h> // You need to import this library from https://github.com/autowp/arduino-mcp2515

struct can_frame canMsg;
MCP2515 mcp2515(10); 

// Send test messages using the serial monitor and the number pad on the keyboard
#define MESSAGE_COUNT 12
char supportedMessages[MESSAGE_COUNT] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-', '+' };
int data0[MESSAGE_COUNT] = { 0x04, 0x10, 0x08, 0x00, 0x00, 0x80, 0x40, 0x00, 0x00, 0x00, 0x00, 0x14 };
int data1[MESSAGE_COUNT] = { 0x00, 0x00, 0x00, 0x80, 0x08, 0x00, 0x00, 0x40, 0x02, 0x01, 0x04, 0x00 };
int subsystemId = 0x3C4;

void setup() {
  SPI.begin();  
  Serial.begin(9600);
  mcp2515.reset();
  mcp2515.setBitrate(CAN_50KBPS,MCP_8MHZ);
  mcp2515.setNormalMode();
}

void loop() {
  while (Serial.available()) {
    char input = Serial.read();
    Serial.println(input);
    for (int i = 0; i < MESSAGE_COUNT; i++) {
      if (supportedMessages[i] == input) {
        sendMessage(subsystemId, data0[i], data1[i]);
        break;
      }
    }
  }
}

void sendMessage(int id, int data1, int data2) {
  canMsg.can_id = id;          
  canMsg.can_dlc = 2;               
  canMsg.data[0] = data1;              
  canMsg.data[1] = data2;               
  bool sent = mcp2515.sendMessage(&canMsg);
  Serial.println(sent);
}
